FUNCTION INVERS(PM)

! calculate the inverse of a symmetric matrix M
REAL, DIMENSION(:,:), INTENT(IN) :: PM
REAL, DIMENSION(SIZE(PM,1),SIZE(PM,1)) :: INVERS

REAL, DIMENSION(SIZE(PM,1),SIZE(PM,1)) :: ZA
REAL, DIMENSION(SIZE(PM,1)) :: ZB
INTEGER, DIMENSION(SIZE(PM,1)) :: INDX
INTEGER :: JI, JJ, JN
REAL :: ZD

INTERFACE
  SUBROUTINE LUDCMP(PA,KNDX,PD)
    USE NRTYPE
    REAL(SP), DIMENSION(:,:), INTENT(INOUT) :: PA
    INTEGER(I4B), DIMENSION(:), INTENT(OUT) :: KNDX
    REAL(SP), INTENT(OUT) :: PD
    END SUBROUTINE LUDCMP
  SUBROUTINE LUBKSB(PA,KNDX,PB)
    USE NRTYPE
    REAL(SP), DIMENSION(:,:), INTENT(IN)   :: PA
    INTEGER(I4B), DIMENSION(:), INTENT(IN) :: KNDX
    REAL(SP), DIMENSION(:), INTENT(INOUT)  :: PB
  END SUBROUTINE LUBKSB
END INTERFACE

ZA = PM
JN = Size(PM,1)

! LU decomposition
CALL LUDCMP(ZA,INDX,ZD)

! calculate the inverse
DO JI = 1, JN
  ZB = 0.
  ZB(JI) = 1.
  CALL LUBKSB(ZA,INDX,ZB)
  INVERS(:,JI) = ZB
END DO

! restore symmetry of the matrix
DO JI = 1,JN
  DO JJ = JI+1,JN
    INVERS(JI,JJ) = 0.5*( INVERS(JI,JJ) + INVERS(JJ,JI) )
    INVERS(JJ,JI) = INVERS(JI,JJ)
  END DO
END DO

END FUNCTION INVERS

