SUBROUTINE LUBKSB(PA,KNDX,PB)

USE NRTYPE
USE NRUTIL, ONLY : ASSERT_EQ

IMPLICIT NONE

REAL(SP), DIMENSION(:,:), INTENT(IN) :: PA
INTEGER(I4B), DIMENSION(:), INTENT(IN) :: KNDX
REAL(SP), DIMENSION(:), INTENT(INOUT) :: PB

INTEGER(I4B) :: JI, JN, JJ, JL
REAL(SP) :: ZSUM

JN = ASSERT_EQ(SIZE(PA,1),SIZE(PA,2),SIZE(KNDX),'lubksb')

JJ = 0
DO JI = 1,JN
  JL = KNDX(JI)
  ZSUM = PB(JL)
  PB(JL) = PB(JI)
  IF ( JJ/=0 ) THEN
    ZSUM = ZSUM - DOT_PRODUCT(PA(JI,JJ:JI-1),PB(JJ:JI-1))
  ELSEIF ( ZSUM/=0. ) THEN
    JJ = JI
  ENDIF
  PB(JI) = ZSUM
ENDDO
DO JI = JN,1,-1
  PB(JI) = ( PB(JI) - DOT_PRODUCT(PA(JI,JI+1:JN),PB(JI+1:JN)) ) / PA(JI,JI)
ENDDO

END SUBROUTINE LUBKSB
