SUBROUTINE LUDCMP(PA,KNDX,PD)

USE NRTYPE
USE NRUTIL, ONLY : ASSERT_EQ, IMAXLOC, NRERROR, OUTERPROD, SWAP

IMPLICIT NONE

REAL(SP), DIMENSION(:,:), INTENT(INOUT) :: PA
INTEGER(I4B), DIMENSION(:), INTENT(OUT) :: KNDX
REAL(SP), INTENT(OUT) :: PD
REAL(SP), DIMENSION(SIZE(PA,1)) :: ZVV 
REAL(SP), PARAMETER :: ZTINY=1.0E-20_SP
INTEGER(I4B) :: JN,JK,IMAX

JN = ASSERT_EQ(SIZE(PA,1),SIZE(PA,2),SIZE(KNDX),'LUDCMP')

PD = 1.0

ZVV = MAXVAL(ABS(PA),DIM=2)

IF (ANY(ZVV == 0.0)) THEN
  PRINT*, 'WARNING: SINGULAR MATRIX IN LUDCMP'
END IF

ZVV = 1.0_SP/ZVV

DO JK = 1,JN
  IMAX = (JK-1) + IMAXLOC(ZVV(JK:JN) * ABS(PA(JK:JN,JK)))
  IF (JK /= IMAX) THEN
    CALL SWAP(PA(IMAX,:),PA(JK,:))
    PD = -PD
    ZVV(IMAX) = ZVV(JK)
  END IF
  KNDX(JK) = IMAX
  IF (PA(JK,JK) == 0.0) PA(JK,JK) = ZTINY
  PA(JK+1:JN,JK)      = PA(JK+1:JN,JK) / PA(JK,JK)
  PA(JK+1:JN,JK+1:JN) = PA(JK+1:JN,JK+1:JN) - OUTERPROD(PA(JK+1:JN,JK),PA(JK,JK+1:JN))
END DO

END SUBROUTINE LUDCMP
