IMPLICIT NONE

INCLUDE 'mpif.h'

!limites: 53N-41N, 6W,10E
INTEGER, PARAMETER :: NCOL0=43200, NLIN=16800, NCOL=43200, NTYPES=18, NTYPES0=20, NFACT=50
INTEGER, PARAMETER :: JLBASE=1200, JL0=0 , JC0=0
!INTEGER, PARAMETER :: NCOL0=43200, NLIN=1440, NCOL=1920, NTYPES=18, NTYPES0=20, NFACT=10
!INTEGER, PARAMETER :: JLBASE=1200, JL0=3240, JC0=20880

!ancien point: 8 / 9 / 416
!INTEGER, PARAMETER :: JLIN0=91, JI0=7, JJ0=1512
INTEGER, PARAMETER :: JLIN0=68, JI0=1, JJ0=1000
!
INTEGER*1, DIMENSION(NCOL0) :: iinter
INTEGER*2, DIMENSION(NTYPES,NFACT,NCOL) :: ierr_guess
INTEGER*1, DIMENSION(NTYPES,NFACT,NCOL) :: ialb_guess, ifrac_guess
INTEGER*1, DIMENSION(NFACT,NCOL) :: ialb_mean

REAL, DIMENSION(NTYPES,NFACT,NCOL) :: zfrac_alb, zalb_eco, zalb_guess, zerr_guess, zalb_a, zerr_a, ztc, zalpha
REAL, DIMENSION(NTYPES,NFACT,NCOL) :: zfrac_alb_old
REAL, DIMENSION(NFACT,NCOL) :: zalb_sat, zalb_mean, zalb_a_mean, zalb_soi, zalb_veg, zfrac_veg, zfrac_veg_old
REAL, DIMENSION(NCOL) :: zfrac0, zpres
REAL, DIMENSION(NTYPES) :: zalb_eco_err, ZT
REAL, DIMENSION(NTYPES,NCOL) :: zveg_eco
real, dimension(ntypes) :: zalb_veg0

REAL :: Zalb_sat_ERR
!
INTEGER :: JDEC, JLIN, JI, JT, NRANK, INFOMPI, IL1, IL2, jj, JID1, JID2, JL1, JL2

CHARACTER(LEN=2), DIMENSION(NTYPES0) :: YNUM
CHARACTER(LEN=4), DIMENSION(36) :: YDEC
CHARACTER(LEN=2), DIMENSION(36) :: YDEC2

! nir
data zalb_veg0/0.,0.25,0.25,0.25,0.25,0.21,0.15,0.15,0.15,0.25,&
              0.30,0.30,0.30,0.30,0.30,0.30,0.25,0.30/
! vis
!data zalb_veg0/0.,0.05,0.05,0.05,0.05,0.05,0.05,0.05,0.05,0.05,&
!              0.10,0.10,0.10,0.10,0.10,0.10,0.05,0.10/

DATA YNUM/"04","05","06","07","08","09","10","11","12",&
          "13","14","15","16","17","18","19","20","21","22","23"/

DATA YDEC/"0105","0115","0125","0205","0215","0225","0305","0315","0325",&
          "0405","0415","0425","0505","0515","0525","0605","0615","0625",&
          "0705","0715","0725","0805","0815","0825","0905","0915","0925",&
          "1005","1015","1025","1105","1115","1125","1205","1215","1225"/

DATA YDEC2/"01","02","01","02","01","02","01","02","01",&
           "02","01","02","01","02","01","02","01","02",&
           "01","02","01","02","01","02","01","02","01",&
           "02","01","02","01","02","01","02","01","02"/
   
CALL MPI_INIT(INFOMPI)

CALL MPI_COMM_RANK(MPI_COMM_WORLD,NRANK,INFOMPI)

! ouverture des fichiers de fractions ecoclimap à 1 km
DO JT = 1,NTYPES0
  OPEN(10+JT,FILE="../frac_ecosg_1km_"//YNUM(JT)//".bin",form="unformatted",&
              access="direct",recl=NCOL0)
  ! pour stocker la frac_alb
  OPEN(300+JT,file='frac_alb_temp_'//YNUM(JT),form="unformatted",access="direct",recl=NCOL)      
ENDDO

! boucle sur les dates 
DO JDEC = 1,36

  print*,'jdec ',JDEC
  ! ouverture alb 1km satellite à désagréger (nir)
  OPEN(101,FILE="../../NEW_ALB/AL-BH-NI_"//YDEC(JDEC)//"_world_2",form="unformatted",&
                access="direct",recl=NCOL0)
  
  ! alb moyen qui sera écrit en sortie à partir du alb analysé
  OPEN(103,FILE="ALB_A_TOT/ALBNIR_A_TOT_"//YDEC(JDEC)//".dir",form="unformatted",&
                access="direct",recl=NCOL)
      
    ! new_albvis_soil2 pour l'albedo du sol visible à 1km
    OPEN(51,FILE='new_albvis_soil2_int',form="unformatted",access="direct",recl=ncol0)
    ! ouverture des fichiers de LAI analysés pour les types de cultures
    DO JT = 16,18
    OPEN(51+JT-15,FILE="LAI_A/LAI_A_T"//YNUM(JT)//"_D"//YDEC(JDEC)//".dir",form="unformatted",&
              access="direct",recl=NCOL0)
    ENDDO

        
    IF (JDEC>1) THEN
      DO JT = 2,NTYPES
        ! alb analysé par vegtype pas de temps précédent (guess) à lire
        OPEN(105+JT,FILE="ALBNIR_A/ALB_NI_A_VEG_T"//YNUM(JT+2)//"_D"//YDEC(JDEC-1)//".dir",form="unformatted",&
                  access="direct",recl=NCOL)
        ! erreur analysée par vegtype pas de temps précédent (guess) à lire
        OPEN(150+JT,FILE="ERR_ALBNIR_A/ERR_NI_A_VEG_T"//YNUM(JT+2)//"_D"//YDEC2(JDEC-1)//".dir",form="unformatted",&
                    access="direct",recl=NCOL*4)
      ENDDO
      OPEN(106,FILE="ALBNIR_A/ALB_NI_A_SOI_D"//YDEC(JDEC-1)//".dir",form="unformatted",&
                access="direct",recl=NCOL)
      ! erreur analysée par vegtype pas de temps précédent (guess) à lire
      OPEN(151,FILE="ERR_ALBNIR_A/ERR_NI_A_SOI_D"//YDEC2(JDEC-1)//".dir",form="unformatted",&
                access="direct",recl=NCOL*4)         
    ENDIF

    ! alb analysé par vegtype à écrire (pas de temps courant) 
    DO JT = 2,NTYPES 
      OPEN(205+JT,FILE="ALBNIR_A/ALB_NI_A_VEG_T"//YNUM(JT+2)//"_D"//YDEC(JDEC)//".dir",form="unformatted",&
                access="direct",recl=NCOL)
      ! erreur analysée par vegtype à écrire (pas de temps courant)        
      OPEN(250+JT,FILE="ERR_ALBNIR_A/ERR_NI_A_VEG_T"//YNUM(JT+2)//"_D"//YDEC2(JDEC)//".dir",form="unformatted",&
                access="direct",recl=NCOL*4)
    ENDDO
    OPEN(206,FILE="ALBNIR_A/ALB_NI_A_SOI_D"//YDEC(JDEC)//".dir",form="unformatted",&
                access="direct",recl=NCOL)
    ! erreur analysée par vegtype à écrire (pas de temps courant)        
    OPEN(251,FILE="ERR_ALBNIR_A/ERR_NI_A_SOI_D"//YDEC2(JDEC)//".dir",form="unformatted",&
                access="direct",recl=NCOL*4)        
        
  !ENDDO

  
  IL1 = (NRANK*42)+1
  IL2 = (NRANK+1)*42

   
  ! boucle sur les lignes des fichiers d'entrée
  DO JLIN = IL1,IL2 

    print*,'JLIN ',JLIN,IL2
    
    JL1 = (JLIN-1)*NFACT + 1
    JL2 = JLIN * NFACT

    zalb_mean(:,:) = 0. 
    
    DO JI = 1,NFACT

      !lecture de l'albedo du sol 
      read(51,rec=jlbase+jl0+(jlin-1)*NFACT+JI) iinter(:)
      where (iinter(jc0+1:jc0+ncol)<0) 
        zalb_soi(JI,:) = (iinter(jc0+1:jc0+ncol) + 256)/100. + 0.1
      else where
        zalb_soi(JI,:) = (iinter(jc0+1:jc0+ncol))/100. + 0.1
      end where      

      zfrac_alb(:,JI,:) = 0.
      zalb_eco(:,JI,:) = 0.
      zpres(:) = 0.
      DO JT = 2,NTYPES

        ! lecture des fractions ²de types
        read(10+2+JT,rec=1200+jl0+(jlin-1)*NFACT+JI) iinter(:)
        zfrac0(:) = iinter(jc0+1:jc0+ncol) / 100.
        
        !print*,jl0+(jlin-1)*NFACT+JI
        if (jt>=13.and.jt<=15) then   
          ! lecture du lai des cultures et calcul du veg
          read(51+jt-12,rec=(jlin-1)*NFACT+JI) iinter(:) !iinter(jc0+1:jc0+ncol)
          where (iinter(jc0+1:jc0+ncol)<0) 
            zveg_eco(jt,:) = 1.-exp(-0.6*float(iinter(jc0+1:jc0+ncol) + 256)/10.)
          else where
            zveg_eco(jt,:) = 1.-exp(-0.6*float(iinter(jc0+1:jc0+ncol))/10.)
          end where          
        elseif (jt==5) then
          zveg_eco(jt,:) = 0.99
        else
          zveg_eco(jt,:) = 0.95
        endif

        ! calcul des fractions pour sol et vegetation
        zfrac_alb(JT,JI,:) = ZVEG_ECO(JT,:) * ZFRAC0(:)

        ! calcul des albedos sol et veg totaux par maille
        zalb_eco(JT,JI,:) = zalb_veg0(JT)

      enddo
      
      zfrac_alb(1,JI,:) = 1. - sum(zfrac_alb(2:NTYPES,JI,:),1)

      zalb_eco(1,JI,:) = zalb_soi(JI,:)

      zalb_mean(JI,:) = 0.
      DO JT = 1,NTYPES
        zalb_mean(JI,:) = zalb_mean(JI,:) + zfrac_alb(JT,JI,:) * zalb_eco(JT,JI,:)
      ENDDO
      
      IF (JDEC>1) THEN

        DO JT = 2,NTYPES
          ! lecture du frac analysé
          read(150+JT,rec=(jlin-1)*NFACT+JI) zerr_guess(JT,JI,:)
          ! lecture du alb analysé       
          read(105+JT,rec=(jlin-1)*NFACT+JI) ialb_guess(JT,JI,:)
          read(300+JT,rec=(jlin-1)*NFACT+JI) ifrac_guess(JT,JI,:)
        ENDDO
        ! lecture du frac analysé
        read(151,rec=(jlin-1)*NFACT+JI) zerr_guess(1,JI,:) 
        ! lecture du alb analysé       
        read(106,rec=(jlin-1)*NFACT+JI) ialb_guess(1,JI,:) 

      ELSE

        zerr_guess(:,JI,:) = 999.
        ialb_guess(:,JI,:) = 0

      ENDIF

   
      ! lecture du alb satellite à 1km moyenné sur les 30 ans : récupérer sur beaufix et décompresser
      read(101,rec=jl0+(jlin-1)*NFACT+JI) iinter(:)
      where (iinter(jc0+1:jc0+ncol)<0) 
        zalb_sat(JI,:) = (iinter(jc0+1:jc0+ncol) + 256)/100.
      else where
        zalb_sat(JI,:) = iinter(jc0+1:jc0+ncol)/100.
      end where

    ENDDO
   
    IF (JDEC>1) THEN
      zalb_guess(:,:,:) = float(ialb_guess(:,:,:))/100.
      !zerr_guess(:,:,:) = float(ierr_guess(:,:,:))/100.
      zfrac_alb_old(:,:,:) = float(ifrac_guess(:,:,:))/100.
      zfrac_alb_old(1,:,:) = 1. - sum(zfrac_alb_old(2:NTYPES,:,:),1)
    ELSE
      zalb_guess(:,:,:) = zalb_eco(:,:,:)
      zerr_guess(:,:,:) = 999.
      zfrac_alb_old(:,:,:) = zfrac_alb(:,:,:)
    ENDIF

    zalb_veg(:,:) = 0.
    zfrac_veg(:,:) = 0.
    zfrac_veg_old(:,:) = 0.
    do jt=2,ntypes
      zalb_veg(:,:) = zalb_veg(:,:) + zfrac_alb_old(jt,:,:) * zalb_guess(jt,:,:)
    enddo
    zfrac_veg(:,:) = 1. - zfrac_alb(1,:,:)
    zfrac_veg_old(:,:) = 1. - zfrac_alb_old(1,:,:)

    !ZTC(1,:,:) = (1.-MIN(0.9,MAX(zfrac_alb(1,:,:),0.1))) + 0.2
    !ZTC(2,:,:) = MIN(0.9,MAX(zfrac_alb(1,:,:),0.1)) + 0.2 
    DO JT = 2,NTYPES
      WHERE (ZALB_GUESS(JT,:,:)/=0.) 
        ZTC(JT,:,:) = (1.-MIN(0.9,MAX(zfrac_alb(JT,:,:),0.1))) + 1. + (1./(zalb_guess(JT,:,:)*500.))
      ELSE WHERE
        ZTC(JT,:,:) = 1.
      END WHERE
    ENDDO
    
    WHERE (ZALB_VEG(:,:)/=0.) 
      ZTC(1,:,:) =     MIN(0.9,MAX(1.-zfrac_alb(1,:,:),0.1)) + 1. + (1./(zalb_veg(:,:)*500.))
    ELSE WHERE
      ZTC(1,:,:) = 1.
    END WHERE
    
    ZT(:) = 2.
    !ZT(:) = 10.
    !ZTC(:,:,:) = 30.
    
    ZALB_ECO_ERR(:) = 2.
    ZALB_SAT_ERR = 0.1
    
    !ZALPHA(:,:,:) = 1. + MIN(1.,ZFRAC_ALB(:,:,:))
    do jt = 2,ntypes
      ZALPHA(jt,:,:) = ( 1. - abs(ZFRAC_ALB_OLD(JT,:,:)-ZFRAC_ALB(JT,:,:)))**2
    enddo
    ZALPHA(1,:,:) = ( 1. + abs(ZFRAC_VEG_OLD(:,:)-ZFRAC_VEG(:,:)))**2
    
    ! appel de la routine
    print*,'veg_analysis in',NRANK
    CALL GENE_ANALYSIS(NTYPES, NFACT, NCOL, ZFRAC_ALB, ZALB_ECO, ZALB_ECO_ERR, ZALB_SAT, ZALB_SAT_ERR, &
                      ZALB_GUESS, ZERR_GUESS, ZT, ZTC, ZALPHA, ZALB_A, ZERR_A, ZALB_A_MEAN)
    print*,'veg_analysis out',NRANK


    !ierr_guess(:,:,:) = nint(zerr_a(:,:,:)*100.)
    !print*,minval(zalb_a(15,:,:)),maxval(zalb_a(15,:,:))
    ialb_guess(:,:,:) = nint(zalb_a(:,:,:)*100.)
    ialb_mean(:,:) = nint(zalb_a_mean(:,:)*100.)

    
    !zfrac_alb_old(:,:,:) = zfrac_alb(:,:,:)
        
    DO JI = 1,NFACT 
        
      DO JT = 1,NTYPES

        ! écriture du frac analysé
        !print*,(jlin-1)*NFACT+JI
        ifrac_guess(JT,JI,:) = nint(zfrac_alb(JT,JI,:)*100.)
        write(300+JT,rec=(jlin-1)*NFACT+JI) ifrac_guess(JT,JI,:)

        write(250+JT,rec=(jlin-1)*NFACT+JI) zerr_a(JT,JI,:)
       
        ! écriture du alb analysé       
        write(205+jt,rec=(jlin-1)*NFACT+JI) ialb_guess(JT,JI,:)

      ENDDO

      ! écriture du alb mean
      write(103,rec=(jlin-1)*NFACT+JI) ialb_mean(JI,:)
        
    ENDDO

  ENDDO

  CLOSE(101)
  !CLOSE(102)
 
  CLOSE(103)
        
  DO JT = 1,NTYPES
    if (jt<=4) CLOSE(50+JT)
    CLOSE(105+JT)
    CLOSE(150+JT)
    CLOSE(205+JT)
    CLOSE(250+JT)  
  ENDDO

ENDDO
! fin des boucles

DO JT = 1,NTYPES0
  CLOSE(10+JT)
  CLOSE(300+JT)   
ENDDO

CALL MPI_FINALIZE(INFOMPI)

      END
