IMPLICIT NONE

INCLUDE 'mpif.h'

!limites: 53N-41N, 6W,10E
INTEGER, PARAMETER :: NCOL0=43200, NLIN=16800, NCOL=43200, NTYPES=20, NFACT=50
INTEGER, PARAMETER :: JL0=0 , JC0=0
!INTEGER, PARAMETER :: NCOL0=43200, NLIN=1440, NCOL=1920, NTYPES=20, NFACT=10
!INTEGER, PARAMETER :: JL0=3240 , JC0=20880

INTEGER, PARAMETER :: JJ0=1783, JI0=796
!
INTEGER*1, DIMENSION(NCOL0) :: iinter
INTEGER*2, DIMENSION(NTYPES,NFACT,NCOL) ::ilai_eco, ierr_guess
INTEGER*1, DIMENSION(NTYPES,NFACT,NCOL) :: ifrac, ilai_guess
INTEGER*2, DIMENSION(NFACT,NCOL) :: ilai_sat
INTEGER*1, DIMENSION(NFACT,NCOL) :: ilai_mean

REAL, DIMENSION(NTYPES,NFACT,NCOL) :: zfrac, zlai_eco, zlai_guess, zerr_guess, zlai_a, zerr_a
REAL, DIMENSION(NFACT,NCOL) :: zlai_sat, zlai_mean, zlai_a_mean

REAL :: ZLAI_ERR
!
INTEGER :: JDEC, JLIN, JI, JT, NRANK, INFOMPI, IL1, IL2, jj

CHARACTER(LEN=2), DIMENSION(NTYPES) :: YNUM
CHARACTER(LEN=4), DIMENSION(36) :: YDEC
CHARACTER(LEN=2), DIMENSION(36) :: YDEC2

DATA YNUM/"04","05","06","07","08","09","10","11","12",&
          "13","14","15","16","17","18","19","20","21","22","23"/

DATA YDEC/"0105","0115","0125","0205","0215","0225","0305","0315","0325",&
          "0405","0415","0425","0505","0515","0525","0605","0615","0625",&
          "0705","0715","0725","0805","0815","0825","0905","0915","0925",&
          "1005","1015","1025","1105","1115","1125","1205","1215","1225"/

DATA YDEC2/"01","02","01","02","01","02","01","02","01",&
           "02","01","02","01","02","01","02","01","02",&
           "01","02","01","02","01","02","01","02","01",&
           "02","01","02","01","02","01","02","01","02"/

CALL MPI_INIT(INFOMPI)

CALL MPI_COMM_RANK(MPI_COMM_WORLD,NRANK,INFOMPI)

DO JT = 1,NTYPES
  OPEN(10+JT,FILE="../frac_ecosg_1km_"//YNUM(JT)//".bin",form="unformatted",&
              access="direct",recl=NCOL0)
ENDDO

!lai sat point d'étude
OPEN(301,file='lai_sat_point_int.txt',form='formatted')
open(302,file='lai_mean_point_int.txt',form='formatted')

open(303,file='lai_eco_t8_int.txt',form='formatted')
open(304,file='lai_eco_t15_int.txt',form='formatted')
open(305,file='lai_eco_t17_int.txt',form='formatted')
open(306,file='lai_eco_t19_int.txt',form='formatted')
!open(307,file='lai_eco_t18_int.txt',form='formatted')

open(308,file='lai_a_t8_int.txt',form='formatted')
open(309,file='lai_a_t15_int.txt',form='formatted')
open(310,file='lai_a_t17_int.txt',form='formatted')
open(311,file='lai_a_t19_int.txt',form='formatted')
!open(312,file='lai_a_t18_int.txt',form='formatted')

open(313,file='err_a_t8_int.txt',form='formatted')
open(314,file='err_a_t15_int.txt',form='formatted')
open(315,file='err_a_t17_int.txt',form='formatted')
open(316,file='err_a_t19_int.txt',form='formatted')
!open(317,file='err_a_t18_int.txt',form='formatted')

open(318,file='lai_a_mean_int.txt',form='formatted')


! boucle sur les dates 
DO JDEC = 1,36

 print*,'jdec ',jdec,NRANK
  ! ouverture LAI 1km satellite à désagréger
  OPEN(101,FILE="../../NEW_LAI2/LAI_"//YDEC(JDEC)//"_world_2",form="unformatted",&
                access="direct",recl=NCOL0)
  ! ouverture erreur lai satellite'
  !OPEN(102,FILE="../../NEW_LAI2/ERR/LAI-ERR_"//YDEC(JDEC)//"_world_2",form="unformatted",&
  !              access="direct",recl=43200)
  
  ! lai moyen qui sera écrit en sortie à partir du LAI analysé
  OPEN(103,FILE="LAI_A_MEAN/LAI_A_MEAN_"//YDEC(JDEC)//".dir",form="unformatted",&
                access="direct",recl=NCOL)
        
  DO JT = 1,NTYPES

    ! LAI par types ECOCLIMAP à lire 
    IF (JT>3) THEN
      OPEN(50+JT,FILE="../../NEW_LAI/TYPES/LAI_T"//YNUM(JT)//"_D"//YDEC(JDEC)//".dir",form="unformatted",&
                  access="direct",recl=NCOL0)
    ENDIF

        
    IF (JDEC>1) THEN
      ! lai analysé par vegtype pas de temps précédent (guess) à lire
      OPEN(105+JT,FILE="LAI_A/LAI_A_T"//YNUM(JT)//"_D"//YDEC(JDEC-1)//".dir",form="unformatted",&
                access="direct",recl=NCOL)
      ! erreur analysée par vegtype pas de temps précédent (guess) à lire
      OPEN(150+JT,FILE="ERR_LAI/ERR_LAI_A_T"//YNUM(JT)//"_D"//YDEC2(JDEC-1)//".dir",form="unformatted",&
                access="direct",recl=NCOL*4)  
    ENDIF

    ! lai analysé par vegtype à écrire (pas de temps courant)       
    OPEN(205+JT,FILE="LAI_A/LAI_A_T"//YNUM(JT)//"_D"//YDEC(JDEC)//".dir",form="unformatted",&
                access="direct",recl=NCOL)
    ! erreur analysée par vegtype à écrire (pas de temps courant)        
    OPEN(250+JT,FILE="ERR_LAI/ERR_LAI_A_T"//YNUM(JT)//"_D"//YDEC2(JDEC)//".dir",form="unformatted",&
                access="direct",recl=NCOL*4)
        
  ENDDO

  
  !IL1 = (NRANK*9)+1
  !IL2 = (NRANK+1)*9
  IL1 = (NRANK*21)+1
  IL2 = (NRANK+1)*21

   

  ! boucle sur les lignes des fichiers d'entrée
  DO JLIN = IL1,IL2 !1,NLIN/NFACT

     !print*,'jlin ',NRANK,JLIN,IL2
    !print*,'jlin ',jlin,IL2 !nlin/nfact

    zlai_mean(:,:) = 0. 
    
    DO JI = 1,NFACT

      !print*,'JI ',JI,NFACT,NRANK
      DO JT = 1,NTYPES

        !print*,'JT ',JT
        ! lecture des fractions de types: dans KALMAN
        !print*,1200+jl0+(jlin-1)*NFACT+JI
        !print*,'read fractions ',NRANK
        read(10+JT,rec=1200+jl0+(jlin-1)*NFACT+JI) iinter(:)
        ifrac(JT,JI,:) = iinter(jc0+1:jc0+ncol)
        !if (jt==ntypes) then
          !do jj=1,size(ifrac,3)
          !  if (sum(ifrac(:,ji,jj))/=100.and.sum(ifrac(:,ji,jj))/=0) &
          !          print*,'HHHHHHHHHHHHHHhhhh ',JJ,JI,sum(ifrac(:,ji,jj))
          !enddo
        !endif

        !if (jt==ntypes .and.jlin==135.and. ji==7.and.nrank==14) then
        !  write(301,fmt=*) 
        !        print*,'frac ',ifrac(:,ji,1783)
          !do jj=1,size(ifrac,3)
          !  if (count(ifrac(1:3,ji,jj)/=0)>0) print*,'frac ',jj,ifrac(:,ji,jj)
          !enddo
        !endif
        
        ! lecture du LAI ECO par types (LAI à 300m moyenné)
        !print*,jl0+(jlin-1)*NFACT+JI
        !print*,'read lai eco par type ',NRANK
        if (jt>3) then
          read(50+jt,rec=jl0+(jlin-1)*NFACT+JI) iinter(:)
        else
          iinter(:) = 0
        endif
        where (iinter(jc0+1:jc0+ncol)<0) 
          ilai_eco(JT,JI,:) = iinter(jc0+1:jc0+ncol) + 256
        else where
          ilai_eco(JT,JI,:) = iinter(jc0+1:jc0+ncol)
        end where
        !if (jt==16.and.maxval(ilai_eco(JT,JI,:))>40..and.jdec==8) then
        !  !print*,nrank,jlin,ji,maxval(ilai_eco(JT,JI,:)),maxloc(ilai_eco(JT,JI,:))
        !endif
        !if (jt==ntypes .and.jlin==135.and. ji==7.and.nrank==14) then
        !  !print*,'lai  point ',ilai_eco(:,ji,1783)
        !endif        
      

        !if (jt==ntypes .and.jlin==135.and. ji==7.and.nrank==14) then
        !  write(303,fmt=*) float(ilai_eco(5,JI,JJ0))/10.
        !  write(304,fmt=*) float(ilai_eco(12,JI,JJ0))/10.
        !  write(305,fmt=*) float(ilai_eco(14,JI,JJ0))/10.
        !  write(306,fmt=*) float(ilai_eco(16,JI,JJ0))/10.
        !  !write(307,fmt=*) float(ilai_eco(15,JI,JJ0))/10.
        !endif
        
        !print*,'calc lai_mean ',NRANK
        zlai_mean(JI,:) = zlai_mean(JI,:) + float(ifrac(JT,JI,:))/100. * float(ilai_eco(JT,JI,:))/10.
        
        !print*,'read err ',NRANK
        IF (JDEC>1) THEN

          ! lecture du frac analysé
          read(150+JT,rec=(jlin-1)*NFACT+JI) zerr_guess(JT,JI,:)
       
          ! lecture du lai analysé       
          read(105+jt,rec=(jlin-1)*NFACT+JI) ilai_guess(JT,JI,:) 

        ELSE

          zerr_guess(JT,JI,:) = 999.
          ilai_guess(JT,JI,:) = 0

        ENDIF

      ENDDO

      !print*,'read lai sat ',NRANK
      ! lecture du LAI satellite à 1km moyenné sur les 30 ans : récupérer sur beaufix et décompresser
      read(101,rec=jl0+(jlin-1)*NFACT+JI) iinter(:)
      where (iinter(jc0+1:jc0+ncol)<0) 
        ilai_sat(JI,:) = iinter(jc0+1:jc0+ncol) + 256
      else where
        ilai_sat(JI,:) = iinter(jc0+1:jc0+ncol)
      end where


      !if (jlin==135.and. ji==7.and.nrank==14) then
      !  write(301,fmt=*) float(ilai_sat(JI,JJ0))/10.
      !  write(302,fmt=*) zlai_mean(JI,JJ0)
      !endif
      !print*,(jlin-1)*NFACT+ji,minval(ilai_sat(ji,:)),maxval(ilai_sat(ji,:))
     
    ENDDO
    
    !print*,NRANK,' etape 1 '
    zfrac(:,:,:) = float(ifrac(:,:,:))/100.
    where (ilai_eco(:,:,:)/=255) 
      zlai_eco(:,:,:) = float(ilai_eco(:,:,:))/10.
    else where
      zlai_eco(:,:,:) = 0.
    end where
    !print*,'lai_eco ',minval(zlai_eco),maxval(zlai_eco)
    zlai_sat(:,:) = float(ilai_sat(:,:))/10.
    zlai_err = 0.5
    !print*,'lai_err ',minval(zlai_err),maxval(zlai_err)
    IF (JDEC>1) THEN
      zlai_guess(:,:,:) = float(ilai_guess(:,:,:))/10.
      !zerr_guess(:,:,:) = float(ierr_guess(:,:,:))/100.
    ELSE
      zlai_guess(:,:,:) = zlai_eco(:,:,:)
      zerr_guess(:,:,:) = 999.
    ENDIF

    ! appel de la routine
    !print*,'lai_analysis in',NRANK
    !if (nrank==14) print*,'JLIN ',JLIN
    CALL LAI_ANALYSIS(NTYPES, NFACT, NCOL, ZFRAC, ZLAI_ECO, ZLAI_SAT, ZLAI_ERR, &
                      ZLAI_GUESS, ZERR_GUESS, ZLAI_A, ZERR_A, ZLAI_A_MEAN)
    !print*,'lai_analysis out',NRANK
!

    !ierr_guess(:,:,:) = nint(zerr_a(:,:,:)*100.)
    ilai_guess(:,:,:) = nint(zlai_a(:,:,:)*10.)
    !print*,'zlai_mean ',minval(zlai_a_mean),maxval(zlai_a_mean)
    ilai_mean(:,:) = nint(zlai_a_mean(:,:)*10.)

    where (ilai_sat(:,:)==255)
      ilai_mean(:,:) = -1
    end where
    where (ilai_eco(:,:,:)==255)
      ilai_guess(:,:,:) = -1
      !ierr_guess(:,:,:) = 999
      zerr_a(:,:,:) = 999.
    end where

    !DO JI = 1,NFACT
    !  if (jlin==135.and. ji==7.and.nrank==14) then
!
!        write(308,fmt=*) zlai_a(5,JI,JJ0)
!        write(309,fmt=*) zlai_a(12,JI,JJ0)
!        write(310,fmt=*) zlai_a(14,JI,JJ0)
!        write(311,fmt=*) zlai_a(16,JI,JJ0)
!        !write(312,fmt=*) zlai_a(15,JI,JJ0)
!
!       !print*,'err ',jdec,zerr_a(5,ji,jj0),zerr_a(12,ji,jj0),zerr_a(14,ji,jj0),zerr_a(16,ji,jj0)
!
!        write(313,fmt=*) zerr_a(5,JI,JJ0)
!        write(314,fmt=*) zerr_a(12,JI,JJ0)
!        write(315,fmt=*) zerr_a(14,JI,JJ0)
!        write(316,fmt=*) zerr_a(16,JI,JJ0)
!        !write(317,fmt=*) zerr_a(15,JI,JJ0) 
!        
!        write(318,fmt=*) zlai_a_mean(JI,JJ0)
!        
!      endif
!    enddo
    
!    ilai_eco(:,:,:) = nint(zlai_eco(:,:,:)*10.)
!    ilai_sat(:,:) = nint(zlai_sat(:,:)*10.)
!    ifrac(:,:,:) = nint(zfrac(:,:,:)*100.)


    DO JI = 1,NFACT

      DO JT = 1,NTYPES

        ! écriture du frac analysé
        !print*,(jlin-1)*NFACT+JI
        write(250+JT,rec=(jlin-1)*NFACT+JI) zerr_a(JT,JI,:)
       
        ! écriture du lai analysé       
        write(205+jt,rec=(jlin-1)*NFACT+JI) ilai_guess(JT,JI,:)
        !do jj=1,size(ilai_eco,3)
        !  if (ilai_eco(JT,JI,jj)==-2) print*,jt,ji,jj,zlai_a(jt,ji,jj)
        !enddo

      ENDDO

      !if (maxval(ilai_mean(JI,:))>70) print*,JLIN,JI,minval(ilai_mean(JI,:)),maxval(ilai_mean(JI,:))
      ! écriture du LAI mean
      write(103,rec=(jlin-1)*NFACT+JI) ilai_mean(JI,:)
        
    ENDDO

  ENDDO

  CLOSE(101)
  !CLOSE(102)
 
  CLOSE(103)
        
  DO JT = 1,NTYPES
    if (jt>3) CLOSE(50+JT)
    CLOSE(105+JT)
    CLOSE(150+JT)
    CLOSE(205+JT)
    CLOSE(250+JT)   
  ENDDO

ENDDO
! fin des boucles

DO JT = 1,NTYPES
  CLOSE(10+JT)
ENDDO

DO JI = 301,318
  CLOSE(JI)
ENDDO

CALL MPI_FINALIZE(INFOMPI)

      END
