set -x
for mois in "01" "02" "03" "04" "05" "06" "07" "08" "09" "10" "11" "12"
do
  for jour in "05" "15" "25"
  do 
    for alb in "NI" "VI"
    do
      file="AL-BH-"${alb}"_AFRI_"${mois}${jour}"_2.bin"
      file_afri=$(basename $file .bin)
      r.in.bin input=/mnt/lfs/d3/surface/faroux/NO_SAVE/NEW_ALB/$file output=$file_afri bytes=1 north=40 south=-40 east=60 west=-30 rows=8961 cols=10081 anull=255 --overwrite

      file="AL-BH-"${alb}"_EURO_"${mois}${jour}"_2.bin"
      file_euro=$(basename $file .bin)
      r.in.bin input=/mnt/lfs/d3/surface/faroux/NO_SAVE/NEW_ALB/$file output=$file_euro bytes=1 north=80 south=30 east=60 west=-30 rows=5601 cols=10081 anull=255 --overwrite

      file="AL-BH-"${alb}"_NOAM_"${mois}${jour}"_2.bin"
      file_noam=$(basename $file .bin)                 
      r.in.bin input=/mnt/lfs/d3/surface/faroux/NO_SAVE/NEW_ALB/$file output=$file_noam bytes=1 north=80 south=10 east=-50 west=-170 rows=7841 cols=13441 anull=255 --overwrite

      file="AL-BH-"${alb}"_SOAM_"${mois}${jour}"_2.bin"
      file_soam=$(basename $file .bin) 
      r.in.bin input=/mnt/lfs/d3/surface/faroux/NO_SAVE/NEW_ALB/$file output=$file_soam bytes=1 north=20 south=-60 east=-30 west=-110 rows=8961 cols=8961 anull=255 --overwrite

      file="AL-BH-"${alb}"_OCEA_"${mois}${jour}"_2.bin"
      file_ocea=$(basename $file .bin)
      r.in.bin input=/mnt/lfs/d3/surface/faroux/NO_SAVE/NEW_ALB/$file output=$file_ocea bytes=1 north=0 south=-50 east=180 west=100 rows=5601 cols=8961 anull=255 --overwrite

      file="AL-BH-"${alb}"_ASIA_"${mois}${jour}"_2.bin"
      file_asia=$(basename $file .bin)                                             
      r.in.bin input=/mnt/lfs/d3/surface/faroux/NO_SAVE/NEW_ALB/$file output=$file_asia bytes=1 north=80 south=0 east=180 west=60 rows=8961 cols=13441 anull=255 --overwrite               


      g.region -p n=80 s=-60 e=180 w=-180 res=0.008928571
      r.patch input=$file_afri,$file_euro,$file_noam,$file_soam,$file_ocea,$file_asia output="AL-BH-"${alb}"_world" --overwrite

      g.remove type=raster name=$file_afri -f
      g.remove type=raster name=$file_euro -f
      g.remove type=raster name=$file_noam -f
      g.remove type=raster name=$file_soam -f
      g.remove type=raster name=$file_ocea -f
      g.remove type=raster name=$file_asia -f

      g.region -p n=80 s=-60 e=180 w=-180 res=0.008333333

      r.resamp.interp input="AL-BH-"${alb}"_world" output="AL-BH-"${alb}"_world_2" method=nearest --overwrite
      r.out.bin -i input="AL-BH-"${alb}"_world_2" output="AL-BH-"${alb}"_"${mois}${jour}"_world_2" null=255 bytes=1 

      g.remove type=raster name="AL-BH-"${alb}"_world" -f
      g.remove type=raster name="AL-BH-"${alb}"_world_2" -f

    done
  done
done
