IMPLICIT NONE

INCLUDE 'mpif.h'

INTEGER*4, PARAMETER :: NLON=120960, NLAT=47040, NFACT=32
INTEGER*1, DIMENSION(36,NLON,NFACT) :: ITAB
CHARACTER(LEN=4), DIMENSION(36) :: YMOIS
INTEGER :: JLAT, JLAT2, IMOIS, JLON, JID, JID1, JID2, JID10, JID20
!INTEGER, DIMENSION(36) :: IFIND
INTEGER*2, DIMENSION(36) :: IVAL
INTEGER :: INFOMPI, NRANK, IL1, IL2



DATA YMOIS/"0105","0115","0125","0205","0215","0225","0305","0315","0325",&
           "0405","0415","0425","0505","0515","0525","0605","0615","0625",&
           "0705","0715","0725","0805","0815","0825","0905","0915","0925",&
           "1005","1015","1025","1105","1115","1125","1205","1215","1225"/


CALL MPI_INIT(INFOMPI)

CALL MPI_COMM_RANK(MPI_COMM_WORLD,NRANK,INFOMPI)

DO JID = 1,36
  OPEN(10+JID,FILE="LAI_"//YMOIS(JID)//".bin",FORM="UNFORMATTED",&
            ACCESS="DIRECT",RECL=NLON)
ENDDO

DO JID = 1,36
  OPEN(100+JID,FILE="LAI_"//YMOIS(JID)//"_2.bin",FORM="UNFORMATTED",&
            ACCESS="DIRECT",RECL=NLON)
ENDDO

IL1 = (NRANK*147) + 1 
IL2 = (NRANK*147) + 147
print*,NRANK,IL1,IL2


DO JLAT = IL1,IL2   !1,NLAT/NFACT !deb: 53

  print*,'JLAT ',NRANK,JLAT,IL1,IL2
  
  DO IMOIS = 1,36
  !print*,IMOIS
    DO JLAT2 = 1,NFACT
      READ(10+IMOIS,REC=(JLAT-1)*NFACT+JLAT2) ITAB(IMOIS,:,JLAT2)
    ENDDO
  ENDDO

  !IFIND(:) = 0

  DO JLAT2 = 1,NFACT
  
    DO JLON = 1,NLON

      IF (ANY(ITAB(:,JLON,JLAT2)/=-1).AND..NOT.ALL(ITAB(:,JLON,JLAT2)/=-1)) THEN

        IVAL = ITAB(:,JLON,JLAT2)
        WHERE (IVAL<0) IVAL = 256 + IVAL

                
            !print*,'ival ',IVAL 
            
          !print*,JLON,JLAT2,COUNT(ITAB(:,JLON,JLAT2)/=-1)
        ! on parcourt les valeurs pour chaque décade
        DO IMOIS = 1,36

          ! si on a une valeur manquante
          IF (IVAL(IMOIS)==255) THEN

            !IFIND(IMOIS) = 1

            !on cherche la première valeur manquante dans les mois précédents
            ! si toutes les valeurs précédentes dans l'année sont manquantes, 
            ! on remonte à l'année précédente
            IF (ALL(IVAL(1:IMOIS)==255)) THEN
              ! de la fin de l'année au mois en cours, on cherche une valeur valide
              DO JID1 = 36,IMOIS,-1
                IF (IVAL(JID1)/=255) EXIT
              ENDDO
              JID10 = JID1
              IF (JID1/=IMOIS) JID10 = JID10 - 36
            ELSE
              ! sinon, on cherche dans le début de l'année
              DO JID1 = IMOIS,0,-1
                IF (JID1==0) EXIT
                IF (IVAL(JID1)/=255) EXIT
              ENDDO
              JID10 = JID1
            ENDIF
            ! si toutes les valeurs suivantes dans l'année sont manquantes
            IF (ALL(IVAL(IMOIS:36)==255))THEN
              ! on cherche dans le début de l'année
              DO JID2 = 1,IMOIS
                IF (IVAL(JID2)/=255) EXIT
              ENDDO
              JID20 = JID2
              IF (JID2/=IMOIS) JID20 = JID20 + 36
            ELSE
              ! sinon on cherche dans la fin de l'année
              DO JID2 = IMOIS,37
                IF (JID2==37) EXIT
                IF (IVAL(JID2)/=255) EXIT
              ENDDO
              JID20 = JID2
            ENDIF
            !IF (IMOIS==1) print*,JID1,JID2
            ! si on a trouvé deux valeurs non manquantes
            IF (JID1/=IMOIS.AND.JID1/=0.AND.JID2/=37.AND.JID2/=IMOIS) THEN
              ! interpolation linéaire
              IVAL(IMOIS) = NINT(IMOIS * FLOAT(IVAL(JID2) - IVAL(JID1)) / (JID20-JID10) + &
                         FLOAT(IVAL(JID1)*JID20 - IVAL(JID2)*JID10 ) / (JID20-JID10) )
            ! si on n'a trouvé qu'une valeur
            ELSEIF (JID1/=0.AND.JID1/=IMOIS) THEN
              IVAL(IMOIS) = IVAL(JID1)
            ELSEIF (JID2/=37.AND.JID2/=IMOIS) THEN
              IVAL(IMOIS) = IVAL(JID2)
            ELSE
              print*,'error point ',JLAT,JLON,JLAT2
              stop
            ENDIF

          ENDIF
                  
      
        ENDDO
 
          ITAB(:,JLON,JLAT2) = IVAL(:)

      ENDIF
   
    ENDDO

  ENDDO

  !print*,ITAB(:,JLON,JLAT2)
  DO JID = 1,36
    !IF (IFIND(JID) == 1) THEN
      DO JLAT2 = 1,NFACT
        WRITE(100+JID,REC=(JLAT-1)*NFACT+JLAT2) ITAB(JID,:,JLAT2)
      ENDDO
    !ENDIF
  ENDDO

ENDDO

DO JID = 1,36
  CLOSE(10+JID)
ENDDO

DO JID = 1,36
  CLOSE(100+JID)
ENDDO

CALL MPI_FINALIZE(INFOMPI)

END
