IMPLICIT NONE

INCLUDE 'mpif.h'

integer*1,dimension(43200*3,3) :: lread
integer*1,dimension(43200*3,3) :: leco
integer*1,dimension(43200,17) :: lwrite
integer*2,dimension(3,3) :: ipix, ieco
integer*4 :: j, i, k, k1, jm, jl, jl2, jc, jt, icount, ival
INTEGER :: NRANK, INFOMPI, IM1, IM2
!
CHARACTER(LEN=2) :: YTYPE
CHARACTER(LEN=4), DIMENSION(36) :: YMOIS

DATA YMOIS/"0105","0115","0125","0205","0215","0225","0305","0315","0325",&
           "0405","0415","0425","0505","0515","0525","0605","0615","0625",&
           "0705","0715","0725","0805","0815","0825","0905","0915","0925",&
           "1005","1015","1025","1105","1115","1125","1205","1215","1225"/

! ouverture fichier ecoclimap
open(11,file='/cnrm/surface/faroux/ecosg_final_map6',form='unformatted',access='direct',recl=43200*3)

CALL MPI_INIT(INFOMPI)

CALL MPI_COMM_RANK(MPI_COMM_WORLD,NRANK,INFOMPI)
IM1 = NRANK * 3 + 1
IM2 = (NRANK+1) * 3
!
! pour chaque décade
DO jm = IM1,IM2

  print*,NRANK,JM
  ! ouverture du fichier de LAI à 300m de cette décade
  open(12,file='LAI_'//YMOIS(jm)//'_2_3',form='unformatted',access='direct',recl=43200*3)

  ! pour chaque type, on ouvre un fichier à 1km du lai pour cette décade
  do jt = 7,23
    write(YTYPE,"(I2.2)") jt
    open(12+jt,file='TYPES/LAI_T'//YTYPE//"_D"//YMOIS(jm)//'.dir',form='unformatted',&
                access='direct',recl=43200)
  enddo

  ! boucle sur les lignes
  do jl = 1,16800
    print*,'jl ',jl
   
    ! lecture de 3 lignes d'un coup
    do jl2 = 1,3

      ! lecture de la ligne ecoclimap
      read(11,rec=10*360+(jl-1)*3+jl2) leco(:,jl2)
      ! lecture du lai 
      read(12,rec=(jl-1)*3+jl2) lread(:,jl2)

    enddo
     
    lwrite(:,:) = 0
    ! boucle sur les points de la ligne
    do jc = 1,43200
      ! on récupère le carré 3*3 de la ligne
      do jl2 = 1,3
        ipix(:,jl2) = lread((jc-1)*3+1:jc*3,jl2)
        ieco(:,jl2) = leco ((jc-1)*3+1:jc*3,jl2)
      enddo
      ! pour chaque type pour lequel le LAI est non nul
      do jt = 7,23
        ! nombre de points du carré qui ont la valeur de ce type
        icount = count(ieco(:,:)==jt)
        ! s'il y a des points qui ont ce type
        if (icount>0) then
          ! la valeur est la moyenne des valeurs pour ce type
          ival = nint (float(sum(ipix(:,:),ieco(:,:)==jt))/float(icount))
          lwrite(jc,jt-6) = ival
        endif
      enddo
    enddo

    ! écriture des lignes de lai à 1km pour chaque type
    do jt  = 7,23
      write(YTYPE,"(I2.2)") jt
      write(12+jt,rec=jl) lwrite(:,jt-6)
    enddo     

  enddo

  ! fermeture des fichiers
  close(12)
  DO jt = 7,23
    close(12+jt)
  enddo

enddo

close(11)

CALL MPI_FINALIZE(INFOMPI)

      END
