IMPLICIT NONE

INCLUDE 'mpif.h'

CHARACTER(LEN=4), DIMENSION(36) :: YMOIS
INTEGER :: JLAT, JLAT2, IMOIS, JLON, JID, JID1, JID2, JID10, JID20
INTEGER :: JCONT, JFIELD
!INTEGER, DIMENSION(36) :: IFIND
INTEGER*2, DIMENSION(36) :: IVAL
INTEGER :: INFOMPI, NRANK, IL1, IL2, JC, JF
CHARACTER(LEN=3), DIMENSION(1) :: YFIELD
CHARACTER(LEN=4), DIMENSION(6) :: YCONT
INTEGER, DIMENSION(6) :: NLON, NLAT, NFACT
INTEGER*1, DIMENSION(:,:,:), ALLOCATABLE :: ITAB

DATA YCONT/"AFRI","EURO","NOAM","SOAM","OCEA","ASIA"/

DATA NLAT/8961,5601,7841,8961,5601,8961/
DATA NLON/8961,10081,13441,8961,8961,13441/

DATA YFIELD/"LAI"/


DATA YMOIS/"0105","0115","0125","0205","0215","0225","0305","0315","0325",&
           "0405","0415","0425","0505","0515","0525","0605","0615","0625",&
           "0705","0715","0725","0805","0815","0825","0905","0915","0925",&
           "1005","1015","1025","1105","1115","1125","1205","1215","1225"/

NFACT(:) = NLAT(:)

CALL MPI_INIT(INFOMPI)

CALL MPI_COMM_RANK(MPI_COMM_WORLD,NRANK,INFOMPI)

IF (NRANK<6) THEN
 JC = NRANK+1
 JF = 1
!ELSE
! JC = NRANK-5
! JF = 1
ENDIF

print*,NRANK,JC,JF

DO JCONT = JC,JC !1,SIZE(YCONT)

  ALLOCATE(ITAB(36,NLON(JCONT),NFACT(JCONT)))

  DO JFIELD = 1,SIZE(YFIELD)

    DO JID = 1,36
      OPEN(10+JID,FILE=YFIELD(JFIELD)//"_"//YCONT(JCONT)//"_"//YMOIS(JID)//".bin",&
              FORM="UNFORMATTED",ACCESS="DIRECT",RECL=NLON(JCONT))
    ENDDO

    DO JID = 1,36
      print*,"write ",YFIELD(JFIELD)//"_"//YCONT(JCONT)//"_"//YMOIS(JID)//"_2.bin"
      OPEN(100+JID,FILE=YFIELD(JFIELD)//"_"//YCONT(JCONT)//"_"//YMOIS(JID)//"_2.bin",&
              FORM="UNFORMATTED",ACCESS="DIRECT",RECL=NLON(JCONT))
    ENDDO

!IL1 = (NRANK*147) + 1 
!IL2 = (NRANK*147) + 147
!print*,NRANK,IL1,IL2


    DO JLAT = 1,NLAT(JCONT)/NFACT(JCONT) !deb: 53

      print*,'JLAT ',NRANK,JLAT,NLAT(JCONT)
  
      DO JID = 1,36
        !print*,IMOIS
        DO JLAT2 = 1,NFACT(JCONT)
          READ(10+JID,REC=(JLAT-1)*NFACT(JCONT)+JLAT2) ITAB(JID,:,JLAT2)
        ENDDO
      
      ENDDO

  !IFIND(:) = 0

      DO JLAT2 = 1,NFACT(JCONT)
  
        DO JLON = 1,NLON(JCONT)

          IF (ALL(ITAB(:,JLON,JLAT2)==0)) THEN

            ITAB(:,JLON,JLAT2) = -1

          ELSEIF (ANY(ITAB(:,JLON,JLAT2)/=-1.AND.ITAB(:,JLON,JLAT2)/=0).AND.&
                  ANY(ITAB(:,JLON,JLAT2)==-1.OR. ITAB(:,JLON,JLAT2)==0)) THEN

            IVAL = ITAB(:,JLON,JLAT2)
            WHERE (IVAL<0) IVAL = 256 + IVAL

                
            !print*,'ival ',IVAL 
            
            !print*,JLON,JLAT2,COUNT(ITAB(:,JLON,JLAT2)/=-1)
            ! on parcourt les valeurs pour chaque décade
            DO IMOIS = 1,36

              ! si on a une valeur manquante
              IF (IVAL(IMOIS)==255.OR.IVAL(IMOIS)==0) THEN

               !IFIND(IMOIS) = 1

                !on cherche la première valeur manquante dans les mois précédents
                ! si toutes les valeurs précédentes dans l'année sont manquantes, 
                ! on remonte à l'année précédente
                IF (ALL(IVAL(1:IMOIS)==255.OR.IVAL(1:IMOIS)==0)) THEN
                  ! de la fin de l'année au mois en cours, on cherche une valeur valide
                  DO JID1 = 36,IMOIS,-1
                    IF (IVAL(JID1)/=255.AND.IVAL(JID1)/=0) EXIT
                  ENDDO
                  JID10 = JID1
                  IF (JID1/=IMOIS) JID10 = JID10 - 36
                ELSE
                  ! sinon, on cherche dans le début de l'année
                  DO JID1 = IMOIS,0,-1
                    IF (JID1==0) EXIT
                    IF (IVAL(JID1)/=255.AND.IVAL(JID1)/=0) EXIT
                  ENDDO
                  JID10 = JID1
                ENDIF
                ! si toutes les valeurs suivantes dans l'année sont manquantes
                IF (ALL(IVAL(IMOIS:36)==255.OR.IVAL(IMOIS:36)==0))THEN
                  ! on cherche dans le début de l'année
                  DO JID2 = 1,IMOIS
                    IF (IVAL(JID2)/=255.AND.IVAL(JID2)/=0) EXIT
                  ENDDO
                  JID20 = JID2
                  IF (JID2/=IMOIS) JID20 = JID20 + 36
                ELSE
                  ! sinon on cherche dans la fin de l'année
                  DO JID2 = IMOIS,37
                    IF (JID2==37) EXIT
                    IF (IVAL(JID2)/=255.AND.IVAL(JID2)/=0) EXIT
                  ENDDO
                  JID20 = JID2
                ENDIF
                !IF (IMOIS==1) print*,JID1,JID2
                ! si on a trouvé deux valeurs non manquantes
                IF (JID1/=IMOIS.AND.JID1/=0.AND.JID2/=37.AND.JID2/=IMOIS) THEN
                  ! interpolation linéaire
                  IVAL(IMOIS) = NINT(IMOIS * FLOAT(IVAL(JID2) - IVAL(JID1)) / (JID20-JID10) + &
                             FLOAT(IVAL(JID1)*JID20 - IVAL(JID2)*JID10 ) / (JID20-JID10) )
                ! si on n'a trouvé qu'une valeur
                ELSEIF (JID1/=0.AND.JID1/=IMOIS) THEN
                  IVAL(IMOIS) = IVAL(JID1)
                ELSEIF (JID2/=37.AND.JID2/=IMOIS) THEN
                  IVAL(IMOIS) = IVAL(JID2)
                ELSE
                  print*,'error point ',JLAT,JLON,JLAT2
                  stop
                ENDIF
                IF (IVAL(IMOIS)<-1 .OR. IVAL(IMOIS)>100) then
                   print*,JLAT,JLAT2,JLON,IMOIS,IVAL(IMOIS)
                   stop
                 ENDIF
  
              ENDIF
                      
            ENDDO
 
            ITAB(:,JLON,JLAT2) = IVAL(:)

          ENDIF
   
        ENDDO

      ENDDO

     !print*,ITAB(:,JLON,JLAT2)
      DO JID = 1,36
        !IF (IFIND(JID) == 1) THEN
        DO JLAT2 = 1,NFACT(JCONT)
          WRITE(100+JID,REC=(JLAT-1)*NFACT(JCONT)+JLAT2) ITAB(JID,:,JLAT2)
        ENDDO
      !ENDIF
      ENDDO

    ENDDO
   
    DO JID = 1,36
      CLOSE(10+JID)
      CLOSE(100+JID)
    ENDDO

  ENDDO
  
  DEALLOCATE(ITAB)
  
ENDDO

CALL MPI_FINALIZE(INFOMPI)

END
