
USE NETCDF

IMPLICIT NONE

!$ INCLUDE 'omp_lib.h'

INCLUDE 'mpif.h'

INTEGER, DIMENSION(6) :: NLON, NLAT, NFACT
INTEGER*1, DIMENSION(:,:), ALLOCATABLE :: ITAB1, ITAB11, ITAB12, ICPTAN, ICPTANB
INTEGER,DIMENSION(:,:), ALLOCATABLE :: ITAB21, ITAB22
REAL*4, DIMENSION(:,:), ALLOCATABLE :: ZTAB1, ZTAB2, ZTAB, ZTABB
CHARACTER(LEN=200) :: YFILENAME1, YFILENAME2
INTEGER :: IFILE_ID1, IFILE_ID2, IRET, IVAR_ID1, IVAR_ID2, JLAT, JLAT2, ITYPE, JDIM, INDIMS
INTEGER, DIMENSION(2) :: ISTART, ICOUNT, IDIMLEN, IDIMIDS
INTEGER :: IAN, IMOIS, NRANK, IM1, IM2, X1, X2, X0, IFIELD, ICONT
CHARACTER(LEN=4), DIMENSION(36) :: YMOIS, YMOIS2
!CHARACTER(LEN=4), DIMENSION(16) :: YAN
CHARACTER(LEN=4), DIMENSION(1) :: YAN
CHARACTER(LEN=4) :: YMM, YMM2
CHARACTER(LEN=3), DIMENSION(1) :: YFIELD
CHARACTER(LEN=4), DIMENSION(6) :: YCONT
INTEGER :: INFOMPI

DATA YCONT/"AFRI","EURO","NOAM","SOAM","OCEA","ASIA"/

DATA NLAT/8961,5601,7841,8961,5601,8961/
DATA NLON/8961,10081,13441,8961,8961,13441/

!DATA YAN/"1999","2000","2001","2002","2003","2004","2005","2006",&
!         "2007","2008","2009","2010","2011","2012","2013","2014"/
DATA YAN/"2003"/

DATA YMOIS/"0103","0113","0124","0203","0213","0221","0303","0313","0324",&
           "0403","0413","0423","0503","0513","0524","0603","0613","0623",&
           "0703","0713","0724","0803","0813","0824","0903","0913","0923",&
           "1003","1013","1024","1103","1113","1123","1203","1213","1224"/

DATA YMOIS2/"0105","0115","0125","0205","0215","0225","0305","0315","0325",&
           "0405","0415","0425","0505","0515","0525","0605","0615","0625",&
           "0705","0715","0725","0805","0815","0825","0905","0915","0925",&
           "1005","1015","1025","1105","1115","1125","1205","1215","1225"/

DATA YFIELD/"LAI"/


ISTART(1) = 1

NFACT(:) = NLAT(:)
!
CALL MPI_INIT(INFOMPI)

CALL MPI_COMM_RANK(MPI_COMM_WORLD,NRANK,INFOMPI)
IM1 = NRANK*6 + 1 
IM2 = (NRANK+1)*6
print*,NRANK,IM1,IM2
! pour chaque décade
DO IMOIS = IM1,IM2

  DO ICONT = 1,SIZE(YCONT)

    print*,NRANK,YCONT(ICONT),IMOIS
    
    ALLOCATE(ITAB1 (NLON(ICONT),NFACT(ICONT)))
    ALLOCATE(ITAB11(NLON(ICONT),NFACT(ICONT)))
    ALLOCATE(ITAB12(NLON(ICONT),NFACT(ICONT)))
    ALLOCATE(ITAB21(NLON(ICONT),NFACT(ICONT)))
    ALLOCATE(ITAB22(NLON(ICONT),NFACT(ICONT)))    
    ALLOCATE(ICPTAN(NLON(ICONT),NFACT(ICONT)))
    !ALLOCATE(ICPTANB(NLON(ICONT),NFACT(ICONT)))
    ALLOCATE(ZTAB1 (NLON(ICONT),NFACT(ICONT)))
    ALLOCATE(ZTAB2 (NLON(ICONT),NFACT(ICONT)))
    !ALLOCATE(ZTABB (NLON(ICONT),NFACT(ICONT)))
    ALLOCATE(ZTAB  (NLON(ICONT),NFACT(ICONT)))

    ICOUNT(1) = NLON(ICONT)
    ICOUNT(2) = NFACT(ICONT)

    DO IFIELD = 1,SIZE(YFIELD)

      ! tableau dans lequel on va écrire le LAI pour cette décade
      OPEN(11,FILE=YFIELD(IFIELD)//"_"//YCONT(ICONT)//"_"&
              //YMOIS2(IMOIS)//".bin",FORM='unformatted',ACCESS='direct',RECL=NLON(ICONT))
      !OPEN(13,FILE=YFIELD(IFIELD)//"_"//YCONT(ICONT)//"_"&
      !        //YMOIS2(IMOIS)//"2.bin",FORM='unformatted',ACCESS='direct',RECL=NLON(ICONT))      
      OPEN(12,FILE="nban.bin",FORM='unformatted',ACCESS='direct',RECL=NLON(ICONT))

  ! boucle sur les latitudes
!!$OMP PARALLEL DO PRIVATE(JLAT,ZTAB,ZTABB,ICPTAN,ISTART,IAN,YFILENAME1,YFILENAME2,IRET,IFILE_ID1,IFILE_ID2,&
!!$OMP IVAR_ID1,IVAR_ID2,ITAB11,ITAB12,ITAB21,ITAB22,ZTAB1,ZTAB2,JLAT2,ICPTANB)
      DO JLAT = 1,NLAT(ICONT)/NFACT(ICONT)

        !print*,NRANK,IMOIS,JLAT,NLAT(ICONT)/NFACT(ICONT)
        !tableau contenant la somme des années pour cette décade et cette fraction de domaine
        ZTAB(:,:) = 0.
        !ZTABB(:,:) = 0.

        ! compteur des années
        ICPTAN(:,:) = 0
        !ICPTANB(:,:) = 0

        ! début de lecture dans le fichier
        ISTART(1) = 1
        ISTART(2) = NFACT(ICONT) * (JLAT-1) + 1

        ! pour chaque année
        DO IAN = 1,SIZE(YAN)
  
          print*,'IAN ',NRANK,IAN
          ! annees bissextiles
          YMM = YMOIS(IMOIS)
          IF (YAN(IAN)=="2000".OR.YAN(IAN)=="2004".OR.YAN(IAN)=="2008".OR.YAN(IAN)=="2012") THEN
            IF (YMOIS(IMOIS)=="0221") YMM = "0222"
          ENDIF

          ! fichier de la décade
          YFILENAME1 = "/cnrm/vegeo/LDAS/OBSERVATIONS/CGLS/LAI_V1/"//YCONT(ICONT)//"/"//YAN(IAN)//YMM//&
                     "/g2_BIOPAR_LAI_"//YAN(IAN)//YMM//"0000_"//YCONT(ICONT)//"_VGT_V1.3.h5"          
          ! fichier de la décade suivante pour la moyenne entre les 2
          IF (IMOIS<SIZE(YMOIS)) THEN
            YMM2 = YMOIS(IMOIS+1)
            IF (YAN(IAN)=="2000".OR.YAN(IAN)=="2004".OR.YAN(IAN)=="2008".OR.YAN(IAN)=="2012") THEN
              IF (YMOIS(IMOIS+1)=="0221") YMM2 = "0222"
            ENDIF
            YFILENAME2 = "/cnrm/vegeo/LDAS/OBSERVATIONS/CGLS/LAI_V1/"//YCONT(ICONT)//"/"//YAN(IAN)//YMM2//&
                       "/g2_BIOPAR_LAI_"//YAN(IAN)//YMM2//"0000_"//YCONT(ICONT)//"_VGT_V1.3.h5"
          ELSE
            YMM2 = YMOIS(1)
            YFILENAME2 = "/cnrm/vegeo/LDAS/OBSERVATIONS/CGLS/LAI_V1/"//YCONT(ICONT)//"/"//YAN(IAN+1)//YMOIS(1)//&
                     "/g2_BIOPAR_LAI_"//YAN(IAN+1)//YMOIS(1)//"0000_"//YCONT(ICONT)//"_VGT_V1.3.h5"
          ENDIF

          ! on ouvre les fichiers netcdf
          IRET = NF90_OPEN(YFILENAME1,NF90_NOWRITE,IFILE_ID1)
          IRET = NF90_OPEN(YFILENAME2,NF90_NOWRITE,IFILE_ID2)
          !print*,'open ',IRET
        
          ! on cherche la variables LAI
          IRET = NF90_INQ_VARID(IFILE_ID1,YFIELD(IFIELD),IVAR_ID1)
          IRET = NF90_INQ_VARID(IFILE_ID2,YFIELD(IFIELD),IVAR_ID2)
          !print*,'varid ',IRET
              
          !IRET = NF90_INQUIRE_VARIABLE(IFILE_ID1,IVAR_ID1,NDIMS=INDIMS)
          !IRET =NF90_INQUIRE_VARIABLE(IFILE_ID1,IVAR_ID1,DIMIDS=IDIMIDS(1:INDIMS))
          !IDIMLEN(:) = 1.
          !DO JDIM=1,INDIMS
          !  IRET=NF90_INQUIRE_DIMENSION(IFILE_ID1,IDIMIDS(JDIM),LEN=IDIMLEN(JDIM))
          !ENDDO        
          !print*,INDIMS,IDIMLEN

          ! on lit la variable LAI 
          !print*,'start ',istart
          !print*,'count ',icount
          !print*,YFILENAME1
          IRET = NF90_GET_VAR(IFILE_ID1,IVAR_ID1,ITAB11,ISTART,ICOUNT)
          !print*,'itab11 ',iret,minval(ITAB11),maxval(ITAB11)
          !if (minval(ITAB11)<0.OR.MAXVAL(ITAB11,ITAB11/=65535)>10000) then
          !        print*,'itab11 ',NRANK,YCONT(ICONT),YFIELD(IFIELD),YAN(IAN),YMOIS(IMOIS),JLAT,&
          !              minval(ITAB11),maxval(ITAB11,ITAB11<65533),maxloc(ITAB11,ITAB11<65533)
          !    stop
          !endif
          !print*,'var1 ',iret
          !print*,YFILENAME2
          IRET = NF90_GET_VAR(IFILE_ID2,IVAR_ID2,ITAB12,ISTART,ICOUNT)
          !print*,'itab12 ',minval(ITAB12),maxval(ITAB12)
          !if (minval(ITAB12)<0.OR.MAXVAL(ITAB12,ITAB12/=65535)>10000) then
          !        print*,'itab22 ',NRANK,YCONT(ICONT),YFIELD(IFIELD),YAN(IAN),YMOIS(IMOIS),JLAT,&
          !        minval(ITAB12),maxval(ITAB12,ITAB12/=65535),maxloc(ITAB12,ITAB12/=65535)
          !   stop
          !endif
          !print*,'var ',IRET
          !print*,minval(ITAB11),maxval(ITAB11)
  
          ! fermeture des fichiers
          IRET = NF90_CLOSE(IFILE_ID1)
          IRET = NF90_CLOSE(IFILE_ID2)
          !print*,'close ',IRET

          !on calcule les valeurs réelles de LAI
          ITAB21 = ITAB11
          WHERE (ITAB11<0) ITAB21 = ITAB11 + 256
          WHERE (ITAB21/=255) 
            ZTAB1 = ITAB21 * 0.033333
          ELSEWHERE
            ZTAB1 = -999.
          ENDWHERE

          ITAB22 = ITAB12
          WHERE (ITAB12<0) ITAB22 = ITAB12 + 256
          WHERE (ITAB22/=255) 
            ZTAB2 = ITAB22 * 0.033333
          ELSEWHERE
            ZTAB2 = -999.
          ENDWHERE

          !print*,"ztab1 ",minval(ZTAB1),minval(ZTAB1,ZTAB1/=-999.),maxval(ZTAB1)
          !print*,"ztab2 ",minval(ZTAB2),minval(ZTAB2,ZTAB2/=-999.),maxval(ZTAB2)

          IF (YMM(3:4)=="03") THEN
            X0 = 5
            X1 = 3
            X2 = 13
          ELSEIF (YMM(3:4)=="13") THEN
            X0 = 15
            X1 = 13
            IF (YMM(1:2)=="04".OR.YMM(1:2)=="06".OR.YMM(1:2)=="09".OR.YMM(1:2)=="11") THEN
              X2 = 23
            ELSEIF (YMM(1:2)=="02") THEN
              X2 = 21
              IF (YMM(3:4) == "22") X2 = 22
            ELSE
              X2 = 24
            ENDIF
          ELSEIF (YMM2(3:4)=="03") THEN
            X0 = 25
            IF (YMM(1:2)=="04".OR.YMM(1:2)=="06".OR.YMM(1:2)=="09".OR.YMM(1:2)=="11") THEN
              X1 = 23
              X2 = 33
            ELSEIF (YMM(1:2)=="02") THEN
              X1 = 21
              X2 = 31
              IF (YMM(3:4) == "22") THEN
                X1 = 22
                X2 = 32
              ENDIF
            ELSE
              X1 = 24
              X2 = 34
            ENDIF
          ENDIF

          !WHERE (ZTAB1/=-999.)
          !  ICPTAN = ICPTAN + 1
          !  ZTAB = ZTAB + ZTAB1
          !END WHERE
        ! 
          !WHERE (ZTAB2/=-999.)   
          !  ICPTANB = ICPTANB + 1
          !  ZTABB = ZTABB + ZTAB2
          !END WHERE
          !print*,"ztab00 ",minval(ZTAB),minval(ZTAB,ZTAB/=-999.),maxval(ZTAB)
          !print*,"ztabb00 ",minval(ZTABB),minval(ZTABB,ZTABB/=-999.),maxval(ZTABB)
          !          print*,X0,X1,X2

          ! on fait la moyenne entre 2 décade et la somme sur les années
          WHERE (ZTAB1/=-999..OR.ZTAB2/=-999.)

            ICPTAN = ICPTAN + 1
            
            WHERE ( ZTAB1/=-999. .AND. ZTAB2/=-999. ) 
              ZTAB = ZTAB + ( (ZTAB1*(X2-X0) + ZTAB2*(X0-X1)) / (X2-X1) )
            ELSEWHERE ( ZTAB1/=-999. ) 
              ZTAB = ZTAB + ZTAB1
            ELSEWHERE ( ZTAB2/=-999. ) 
              ZTAB = ZTAB + ZTAB2
            ENDWHERE
          
          ENDWHERE

        ENDDO
        !print*,'ztab ',minval(ZTAB),maxval(ZTAB)
        ! fin de la boucle sur les années

        !  print*,"ztab0 ",minval(ZTAB),minval(ZTAB,ZTAB/=-999.),maxval(ZTAB)
        !  print*,"ztabb0 ",minval(ZTABB),minval(ZTABB,ZTABB/=-999.),maxval(ZTABB)

        !  moyenne des valeurs sur les années disponible
        WHERE (ICPTAN/=0) 
          ZTAB = ZTAB / ICPTAN
        ELSEWHERE
          ZTAB = -999.
        END WHERE
        !WHERE (ICPTANB/=0) 
        !  ZTABB = ZTABB / ICPTANB
        !ELSEWHERE
        !  ZTABB = -999.
        !END WHERE

        !  print*,"ztab ",minval(ZTAB),minval(ZTAB,ZTAB/=-999.),maxval(ZTAB)
        !  print*,"ztabb ",minval(ZTABB),minval(ZTABB,ZTABB/=-999.),maxval(ZTABB)

        ! if (minval(ZTAB,ZTAB/=-999.)<0..OR.maxval(ztab)>1.) then
        !   print*,'ztab ',NRANK,YCONT(ICONT),YFIELD(IFIELD),YMOIS(IMOIS),JLAT,&
        !                minval(ZTAB,ZTAB/=-999.),maxval(ZTAB),maxloc(ZTAB)
        !  stop
        ! endif
         
               ! print*,'aver ',NRANK,minval(ZTAB,ZTAB/=-999.),maxval(ZTAB)

        ! on traduit en entier pour l'écriture du fichier
        WHERE (ZTAB/=-999.) 
          ITAB1 = NINT(ZTAB*10.)
        ELSEWHERE 
          ITAB1 = -1
        ENDWHERE
       ! print*,'itab1 ',minval(ITAB1),maxval(ITAB1)

        ! écriture dans le fichier de sortie
        DO JLAT2 = 1,NFACT(ICONT)
          WRITE(11,REC=ISTART(2)+JLAT2-1) ITAB1(:,JLAT2)
          WRITE(12,REC=ISTART(2)+JLAT2-1) ICPTAN(:,JLAT2)
        ENDDO

       ! WHERE (ZTABB/=-999.) 
       !   ITAB1 = NINT(ZTABB*10.)
       ! ELSEWHERE 
       !   ITAB1 = -1
       ! ENDWHERE
       ! print*,'itab1 ',minval(ITAB1),maxval(ITAB1)
!
!        ! écriture dans le fichier de sortie
!        DO JLAT2 = 1,NFACT(ICONT)
!          WRITE(13,REC=ISTART(2)+JLAT2-1) ITAB1(:,JLAT2)
!        ENDDO

      ENDDO
!!$OMP END PARALLEL DO 
  ! fin de la boucle sur les fractions de domaine
  
  ! fermeture du fichier binaire  
      CLOSE(11)
      CLOSE(12)
   !   CLOSE(13)

    ENDDO
    
    DEALLOCATE(ITAB1 )
    DEALLOCATE(ITAB11)
    DEALLOCATE(ITAB12)
    DEALLOCATE(ITAB21)
    DEALLOCATE(ITAB22)    
    DEALLOCATE(ICPTAN)
    DEALLOCATE(ZTAB1 )
    DEALLOCATE(ZTAB2 )
    DEALLOCATE(ZTAB  )
   ! DEALLOCATE(ZTABB )
   ! DEALLOCATE(ICPTANB)

  ENDDO

ENDDO
! fin de la boucle sur les décades

CALL MPI_FINALIZE(INFOMPI)

      END
